'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var hookApis = ['useState', 'useReducer', 'useContext', 'useCallback', 'useImperativeMethods', 'useEffect', 'useMutationEffect', 'useLayoutEffect', 'useMemo', 'useRef'];

var miscApis = ['Fragment', 'Component', 'PureComponent', 'Suspense', 'createContext', 'createElement', 'createFactory', 'cloneElement', 'isValidElement', 'Children', 'forwardRef', 'createRef', 'lazy', 'memo'];

var allApis = miscApis.concat(hookApis);

var visitor = exports.visitor = function (t) {
  return {
    Identifier(path) {
      if (checkIfReactHookAPI(path)) {
        var newME = t.memberExpression(t.identifier('React'), t.identifier(path.node.name));
        path.replaceWith(newME);
        path.skip();
      }
    }
  };
};

function checkIfReactHookAPI(path) {
  // return false if inside a member expression already
  if (path.parentPath.isMemberExpression()) return false;
  return allApis.includes(path.node.name);
}